package jp.gr.java_conf.coskx.gles2sample02e;

import android.os.Bundle;

import com.google.android.material.floatingactionbutton.FloatingActionButton;
import com.google.android.material.snackbar.Snackbar;

import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import android.view.GestureDetector;
import android.view.MotionEvent;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;

public class MainActivity extends AppCompatActivity {
    private MyGLSurfaceView glView;
    private GestureDetector gesDetector = null;

    private static final int MENU_ID_MENU1 = 1;
    private static final int MENU_ID_MENU2 = 2;
    private static final int MENU_ID_MENU3 = 3;
    private boolean visible = true;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Toolbar toolbar = findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        //GLサーフェスビュー
        glView=(MyGLSurfaceView)findViewById(R.id.id_myGLview);
        gesDetector = new GestureDetector(this, (GestureDetector.OnGestureListener) glView);

        FloatingActionButton fab = findViewById(R.id.fab);
        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Snackbar.make(view, "Replace with your own action", Snackbar.LENGTH_LONG)
                        .setAction("Action", null).show();
            }
        });
    }

    @Override
    public boolean onTouchEvent(MotionEvent event){
        return gesDetector.onTouchEvent(event);
    }

    //アクティビティレジューム時に呼ばれる
    @Override
    public void onResume() {
        super.onResume();
        glView.onResume();
    }

    //アクティビティポーズ時に呼ばれる
    @Override
    public void onPause() {
        super.onPause();
        glView.onPause();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        menu.add(Menu.NONE, MENU_ID_MENU1, Menu.NONE, "正回転");
        menu.add(Menu.NONE, MENU_ID_MENU2, Menu.NONE, "止まる");
        menu.add(Menu.NONE, MENU_ID_MENU3, Menu.NONE, "逆回転");
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }
        if (id == MENU_ID_MENU1) {
            glView.setRotationVelocity(1f);
            return true;
        } else if (id == MENU_ID_MENU2) {
            glView.setRotationVelocity(0f);
            return true;
        } else if (id == MENU_ID_MENU3) {
            glView.setRotationVelocity(-1f);
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
