package jp.gr.java_conf.coskx.gles2sample02e3;

import androidx.appcompat.app.AppCompatActivity;
import android.os.Bundle;
import android.view.GestureDetector;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.ImageButton;

//public class MainActivity extends AppCompatActivity {
public class MainActivity extends AppCompatActivity {

    private MyGLSurfaceView glView;
    private GestureDetector gesDetector = null;

    public View mTableLayout;

    private ImageButton btnleft;
    private ImageButton btnstop;
    private ImageButton btnright;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        //GLサーフェスビュー
        glView=(MyGLSurfaceView)findViewById(R.id.id_myGLview);
        gesDetector = new GestureDetector(this, (GestureDetector.OnGestureListener) glView);

        //上面のtablelayoutを取得
        mTableLayout=(View)findViewById(R.id.UpperLayout);
        glView.setUpperLayout(mTableLayout);

        //buttonを取得
        btnleft = (ImageButton)findViewById(R.id.b_left);
        btnleft.setOnClickListener(clicked);
        btnstop = (ImageButton)findViewById(R.id.b_stop);
        btnstop.setOnClickListener(clicked);
        btnright = (ImageButton)findViewById(R.id.b_right);
        btnright.setOnClickListener(clicked);
    }

    private View.OnClickListener clicked = new View.OnClickListener() {
        public void onClick(View v) {
            switch (v.getId()) {
                case R.id.b_left:
                    glView.setRotationVelocity(-1f);
                    break;
                case R.id.b_stop:
                    glView.setRotationVelocity(0f);
                    break;
                case R.id.b_right:
                    glView.setRotationVelocity(1f);
                    break;
            }
            mTableLayout.setVisibility(View.INVISIBLE);
        }
    };

    @Override
    public boolean onTouchEvent(MotionEvent event){
        return gesDetector.onTouchEvent(event);
    }
}
