package jp.gr.java_conf.coskx.gles2sample09;

import android.opengl.GLES20;

import java.nio.ShortBuffer;
import java.nio.FloatBuffer;

/**
 * Created by Tommy on 2015/06/27.
 */
public class Line_PtoP {
    //buffer
    private FloatBuffer vertexBuffer;
    private ShortBuffer indexBuffer;
    private int NumIndexes;
    private short[] indexs;
    private float[] vertexs;

    //コンストラクタ
    Line_PtoP(){
    }

    //2点間の接続線を描く
    // p0x,p0y,p0z,p1x,p1y,p1z のみ与える
    public void setVertexs(float p0[],float p1[]){
        NumIndexes=2;
        indexs = new short[NumIndexes];
        indexs[0]=0;
        indexs[1]=1;
        vertexs = new float[NumIndexes*3];
        System.arraycopy(p0, 0, vertexs, 0, 3);
        System.arraycopy(p1, 0, vertexs, 3, 3);
        vertexBuffer = BufferUtil.makeFloatBuffer(vertexs);
        indexBuffer = BufferUtil.makeShortBuffer(indexs);
    }

    // p0x,p0y,p0z,p1x,p1y,p1z,p2x,p2y,p2z,...を与える
    public void setVertexs(float points[]){
        NumIndexes=points.length/3;
        indexs = new short[NumIndexes];
        for (int i=0; i<NumIndexes; i++) indexs[i]=(short)i;
        //vertexs = new float[NumIndexes*3];
        //System.arraycopy(points, 0, vertexs, 0, NumIndexes*3);
        //vertexBuffer = BufferUtil.makeFloatBuffer(vertexs);
        vertexBuffer = BufferUtil.makeFloatBuffer(points);
        indexBuffer = BufferUtil.makeShortBuffer(indexs);
    }

    public void draw(float r,float g,float b,float a, float shininess, float linewidth){
        //頂点点列
        GLES20.glVertexAttribPointer(GLES.positionHandle, 3,
                GLES20.GL_FLOAT, false, 0, vertexBuffer);

        //shadingを使わない時に使う単色の設定 (r, g, b,a)
        GLES20.glUniform4f(GLES.objectColorHandle, r, g, b, a);

        //線の太さ
        GLES20.glLineWidth(linewidth);

        indexBuffer.position(0);
        GLES20.glDrawElements(GLES20.GL_LINES,
                NumIndexes, GLES20.GL_UNSIGNED_SHORT, indexBuffer);
    }
}
