package jp.gr.java_conf.coskx.gles2sample09r;

import androidx.appcompat.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Display;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {
    private MyGLSurfaceView glView;
    private RotationSensor myRotationSensor;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //GLサーフェスビュー
        glView=new MyGLSurfaceView(this);
        setContentView(glView); //これでviewを設置している

        Display mDisplay = getWindowManager().getDefaultDisplay();
        myRotationSensor = new RotationSensor(this, mDisplay);
        glView.renderer.setRotationSensor(myRotationSensor);

    }

    //アクティビティレジューム時に呼ばれる
    @Override
    public void onResume() {
        super.onResume();
        glView.onResume();
        int res=myRotationSensor.setSensorsOn();
        if (res==-1) {
                Toast.makeText(this, "No Rotation vector Sensor", Toast.LENGTH_LONG).show();
        }
    }

    //アクティビティポーズ時に呼ばれる
    @Override
    public void onPause() {
        super.onPause();
        myRotationSensor.setSensorsOff();
        glView.onPause();
    }

}
