package jp.gr.java_conf.coskx.gles2sample09r2;

import androidx.appcompat.app.AppCompatActivity;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.Display;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {
    private MyGLSurfaceView glView;
    private RotationSensor myRotationSensor;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //ポートレイト固定
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

        //GLサーフェスビュー
        glView=new MyGLSurfaceView(this);
        setContentView(glView); //これでviewを設置している

        Display mDisplay = getWindowManager().getDefaultDisplay();
        myRotationSensor = new RotationSensor(this, mDisplay);
        glView.renderer.setRotationSensor(myRotationSensor);

    }

    //アクティビティレジューム時に呼ばれる
    @Override
    public void onResume() {
        super.onResume();
        glView.onResume();
        int res=myRotationSensor.setSensorsOn();
        switch (res) {
            case 0:
                Toast.makeText(this, "No Attitude Sensor", Toast.LENGTH_LONG).show();
                break;
            case 1:
                Toast.makeText(this, "Available Rotation Vector Sensor and Gyroscope", Toast.LENGTH_LONG).show();
                break;
            case 2:
                Toast.makeText(this, "just Available magnetic_field and accelerometer Sensor", Toast.LENGTH_LONG).show();
                break;
        }
    }

    //アクティビティポーズ時に呼ばれる
    @Override
    public void onPause() {
        super.onPause();
        myRotationSensor.setSensorsOff();
        glView.onPause();
    }

}
