package jp.gr.java_conf.coskx.gles2sample11g;

import android.opengl.GLES20;

import java.nio.ByteBuffer;
import java.nio.FloatBuffer;

/**
 * Created by tommy on 2015/12/11.
 */
public class RectangularGradation {
    //bufferの定義
    private FloatBuffer vertexBuffer;
    private ByteBuffer indexBuffer;
    private FloatBuffer colorBuffer;

    //頂点座標
    private float[] vertexs= new float[4*3];

    //頂点座標番号列
    private byte[] indexs= {
            0,2,1,3
    };
    //頂点の色
    private float[] colors= {
            0f,0f,0f,1f,
            0f,0f,0f,1f,
            0f,0f,0f,1f,
            0f,0f,0f,1f
    };

    RectangularGradation(float width, float height, float[] colTopLeft, float[] colTopRight, float[] colBottomLeft, float[] colBottomRight) {
        setRectangular(width, height, colTopLeft, colTopRight, colBottomLeft, colBottomRight);
    }

    RectangularGradation(float[] colTopLeft, float[] colTopRight, float[] colBottomLeft, float[] colBottomRight) {
        setRectangular(1f, 1f, colTopLeft, colTopRight, colBottomLeft, colBottomRight);
    }

    public void setRectangular(float width, float height, float[] colTopLeft, float[] colTopRight, float[] colBottomLeft, float[] colBottomRight) {
        float top=height*.5f;
        float bottom=-top;
        float right=width*.5f;
        float left=-right;
        int i;
        int size=colTopLeft.length;
        for (i=0; i<size; i++) {
            colors[i]=colTopLeft[i];
            colors[i+4]=colTopRight[i];
            colors[i+8]=colBottomLeft[i];
            colors[i+12]=colBottomRight[i];
        }

        //頂点座標
        float[] vertexs= {
                left, top, 0f,     //左上 0
                right, top, 0f,    //右上 1
                left, bottom, 0f,  //左下 2
                right, bottom, 0f      //右下 3
        };
        vertexBuffer=BufferUtil.makeFloatBuffer(vertexs);
        indexBuffer=BufferUtil.makeByteBuffer(indexs);
        colorBuffer=BufferUtil.makeFloatBuffer(colors);
    }

    public void draw() {
        //頂点点列
        GLES20.glVertexAttribPointer(GLES.positionHandle, 3,
                GLES20.GL_FLOAT, false, 0, vertexBuffer);

        //頂点での色
        GLES20.glVertexAttribPointer(GLES.colorHandle, 4,
                GLES20.GL_FLOAT, false, 0, colorBuffer);

        //描画
        indexBuffer.position(0);
        GLES20.glDrawElements(GLES20.GL_TRIANGLE_STRIP,
                4, GLES20.GL_UNSIGNED_BYTE, indexBuffer);
    }
}
