package jp.gr.java_conf.coskx.gles2sample11h;

import android.opengl.GLES20;

import java.nio.FloatBuffer;

/**
 * Created by tommy on 2018/01/14.
 */

public class TexPointSprite {
    //buffer
    private FloatBuffer vertexBuffer;
    private FloatBuffer texcoordBuffer;
    //private ByteBuffer indexBuffer;
    //private FloatBuffer normalBuffer;
    float[] vertexs;
    private int numVertexes;

    //コンストラクタ
    TexPointSprite(int n) { //nは点の数 255以下
        vertexs = new float[n*3];
        vertexBuffer = BufferUtil.makeFloatBuffer(vertexs);
        numVertexes=n;
        if (n==1) {
            vertexs[0]=vertexs[1]=vertexs[2]=0f;
            BufferUtil.setFloatBuffer(vertexs,vertexBuffer);
        }
    }

    public void setVertexs(float p[]){ //コンストラクタで指示した点の数だけ，ｘ,y,z, x,y,z, x,y,z,・・ 点の数×3の配列
        System.arraycopy(p, 0, vertexs, 0, numVertexes*3);
        BufferUtil.setFloatBuffer(vertexs,vertexBuffer);
    }

    public void draw(float pointsize){
        //点列
        GLES20.glVertexAttribPointer(GLES.positionHandle, 3,
                GLES20.GL_FLOAT, false, 0, vertexBuffer);

        //パーティクルのサイズ設定
        GLES20.glUniform1f(GLES.pointSizeHandle, pointsize);

        GLES20.glDrawArrays(GLES20.GL_POINTS, 0, numVertexes);
    }

}

