package jp.gr.java_conf.coskx.gles2sample14;

import android.opengl.Matrix;

/**
 * Created by tommy on 2016/10/10.
 */

public class Droid {
    private float[] Head1Matrix = new float[16];
    private float[] Head2Matrix = new float[16];
    private float[] LeftEyeMatrix = new float[16];
    private float[] RightEyeMatrix = new float[16];
    private float[] LeftPole1Matrix = new float[16];
    private float[] RightPole1Matrix = new float[16];
    private float[] LeftPole2Matrix = new float[16];
    private float[] RightPole2Matrix = new float[16];
    private float[] LeftArm1Matrix = new float[16];
    private float[] RightArm1Matrix = new float[16];
    private float[] LeftArm2Matrix = new float[16];
    private float[] RightArm2Matrix = new float[16];
    private float[] LeftArm3Matrix = new float[16];
    private float[] RightArm3Matrix = new float[16];
    private float[] LeftLeg1Matrix = new float[16];
    private float[] RightLeg1Matrix = new float[16];
    private float[] LeftLeg2Matrix = new float[16];
    private float[] RightLeg2Matrix = new float[16];
    private float[] Body1Matrix = new float[16];
    private float[] Body2Matrix = new float[16];
    private float[] Body3Matrix = new float[16];
    private float[] Body4Matrix = new float[16];

    Droid() {
        //ドロイド君の描画
        float headfact1=.9f; //頭部の縦圧縮率
        float headfact2=.5f; //頭部の上方向移動量
        //頭mHemisphereの描画
        Matrix.setIdentityM(Head1Matrix, 0);
        Matrix.translateM(Head1Matrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(Head1Matrix, 0, 0.3f, 0.3f*headfact1, 0.3f);
        //頭mDisk円盤の描画
        Matrix.setIdentityM(Head2Matrix, 0);
        Matrix.translateM(Head2Matrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(Head2Matrix, 0, 0.3f, 0.3f*headfact1, 0.3f);
        Matrix.rotateM(Head2Matrix, 0, 180f, 0, 0, 1);
        //左目mHemisphereの描画
        Matrix.setIdentityM(LeftEyeMatrix, 0);
        Matrix.translateM(LeftEyeMatrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(LeftEyeMatrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(LeftEyeMatrix, 0, 25f, 0, 1, 0);
        Matrix.rotateM(LeftEyeMatrix, 0, -30f, 1, 0, 0);
        Matrix.translateM(LeftEyeMatrix, 0, 0f, 0f, .28f);
        Matrix.rotateM(LeftEyeMatrix, 0, 90f, 1, 0, 0);
        Matrix.scaleM(LeftEyeMatrix, 0, 0.03f, 0.03f, 0.03f);
        //右目mHemisphereの描画
        Matrix.setIdentityM(RightEyeMatrix, 0);
        Matrix.translateM(RightEyeMatrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(RightEyeMatrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(RightEyeMatrix, 0, -25f, 0, 1, 0);
        Matrix.rotateM(RightEyeMatrix, 0, -30f, 1, 0, 0);
        Matrix.translateM(RightEyeMatrix, 0, 0f, 0f, .28f);
        Matrix.rotateM(RightEyeMatrix, 0, 90f, 1, 0, 0);
        Matrix.scaleM(RightEyeMatrix, 0, 0.03f, 0.03f, 0.03f);
        //左角mCylinderの描画
        Matrix.setIdentityM(LeftPole1Matrix, 0);
        Matrix.translateM(LeftPole1Matrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(LeftPole1Matrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(LeftPole1Matrix, 0, 25, 0, 0, 1);
        Matrix.scaleM(LeftPole1Matrix, 0, 0.02f, 0.4f, 0.02f);
        //右角mCylinderの描画
        Matrix.setIdentityM(RightPole1Matrix, 0);
        Matrix.translateM(RightPole1Matrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(RightPole1Matrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(RightPole1Matrix, 0, -25, 0, 0, 1);
        Matrix.scaleM(RightPole1Matrix, 0, 0.02f, 0.4f, 0.02f);
        //左角のふたmHemisphereの描画
        Matrix.setIdentityM(LeftPole2Matrix, 0);  //ここではすでに設定されているので省略可
        Matrix.translateM(LeftPole2Matrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(LeftPole2Matrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(LeftPole2Matrix, 0, 25, 0, 0, 1);
        Matrix.translateM(LeftPole2Matrix, 0, 0f, 0.4f, 0f);
        Matrix.scaleM(LeftPole2Matrix, 0, 0.02f, 0.02f, 0.02f);
        //右角のふたmHemisphereの描画
        Matrix.setIdentityM(RightPole2Matrix, 0);  //ここではすでに設定されているので省略可
        Matrix.translateM(RightPole2Matrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(RightPole2Matrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(RightPole2Matrix, 0, -25, 0, 0, 1);
        Matrix.translateM(RightPole2Matrix, 0, 0f, 0.4f, 0f);
        Matrix.scaleM(RightPole2Matrix, 0, 0.02f, 0.02f, 0.02f);

        float lhandfact1=0.1f; //左腕上方向移動量
        float rhandfact1=0.1f+.33f; //左腕上方向移動量
        float hendfat2=.32f; //腕の長さ
        float hendfat3=.38f; //腕の横方向移動距離
        //左腕mCylinderの描画
        Matrix.setIdentityM(LeftArm1Matrix, 0);
        Matrix.translateM(LeftArm1Matrix, 0, hendfat3, lhandfact1, 0f);
        Matrix.scaleM(LeftArm1Matrix, 0, 0.07f, hendfat2, 0.07f);
        //右腕mCylinderの描画
        Matrix.setIdentityM(RightArm1Matrix, 0);
        Matrix.translateM(RightArm1Matrix, 0, -hendfat3, rhandfact1, 0f);
        Matrix.scaleM(RightArm1Matrix, 0, 0.07f, hendfat2, 0.07f);
        //左腕のふた上mHemisphereの描画
        Matrix.setIdentityM(LeftArm2Matrix, 0);
        Matrix.translateM(LeftArm2Matrix, 0, hendfat3, hendfat2+lhandfact1, 0f);
        Matrix.scaleM(LeftArm2Matrix, 0, 0.07f, 0.07f, 0.07f);
        //右腕のふた上mHemisphereの描画
        Matrix.setIdentityM(RightArm2Matrix, 0);
        Matrix.translateM(RightArm2Matrix, 0, -hendfat3, hendfat2+rhandfact1, 0f);
        Matrix.scaleM(RightArm2Matrix, 0, 0.07f, 0.07f, 0.07f);
        //左腕のふた下mHemisphereの描画
        Matrix.setIdentityM(LeftArm3Matrix, 0);
        Matrix.translateM(LeftArm3Matrix, 0, hendfat3, lhandfact1, 0f);
        Matrix.rotateM(LeftArm3Matrix, 0, 180, 0, 0, 1);
        Matrix.scaleM(LeftArm3Matrix, 0, 0.07f, 0.07f, 0.07f);
        //右腕のふた下mHemisphereの描画
        Matrix.setIdentityM(RightArm3Matrix, 0);
        Matrix.translateM(RightArm3Matrix, 0, -hendfat3,rhandfact1, 0f);
        Matrix.rotateM(RightArm3Matrix, 0, 180, 0, 0, 1);
        Matrix.scaleM(RightArm3Matrix, 0, 0.07f, 0.07f, 0.07f);

        //左足mCylinderの描画
        Matrix.setIdentityM(LeftLeg1Matrix, 0);
        Matrix.translateM(LeftLeg1Matrix, 0, 0.15f,-0.2f, 0f);
        Matrix.scaleM(LeftLeg1Matrix, 0, 0.06f, 0.2f, 0.1f);
        //右足mCylinderの描画
        Matrix.setIdentityM( RightLeg1Matrix, 0);
        Matrix.translateM( RightLeg1Matrix, 0, -0.15f,-0.2f, 0f);
        Matrix.scaleM( RightLeg1Matrix, 0, 0.06f, 0.2f, 0.1f);
        //左足のふた下mHemisphereの描画
        Matrix.setIdentityM(LeftLeg2Matrix, 0);
        Matrix.translateM(LeftLeg2Matrix, 0, 0.15f, -0.2f, 0f);
        Matrix.rotateM(LeftLeg2Matrix, 0, 180, 0, 0, 1);
        Matrix.scaleM(LeftLeg2Matrix, 0, 0.06f, 0.06f, 0.1f);
        //右足のふた下mHemisphereの描画
        Matrix.setIdentityM(RightLeg2Matrix, 0);
        Matrix.translateM(RightLeg2Matrix, 0, -0.15f, -0.2f, 0f);
        Matrix.rotateM(RightLeg2Matrix, 0, 180, 0, 0, 1);
        Matrix.scaleM(RightLeg2Matrix, 0, 0.06f, 0.06f, 0.1f);

        //胴体mCylinderの描画
        Matrix.setIdentityM(Body1Matrix, 0);
        Matrix.translateM(Body1Matrix, 0, 0f, 0.05f, 0f);
        Matrix.scaleM(Body1Matrix, 0, 0.3f, 0.43f, 0.3f);
        //胴体下部mDisk円盤の描画
        Matrix.setIdentityM(Body2Matrix, 0);
        Matrix.scaleM(Body2Matrix, 0, 0.25f*1.1f, 0.25f, 0.25f*1.1f);
        Matrix.rotateM(Body2Matrix, 0, 180f, 0, 0, 1);
        //胴体上部mDisk円盤の描画
        Matrix.setIdentityM(Body3Matrix, 0);
        Matrix.translateM(Body3Matrix, 0, 0f, 0.48f, 0f);
        Matrix.scaleM(Body3Matrix, 0, 0.3f, 0.3f, 0.3f);
        //胴体下部１/４トーラスの描画
        Matrix.setIdentityM(Body4Matrix, 0);
        Matrix.translateM(Body4Matrix, 0, 0f, 0.05f, 0f);
        Matrix.scaleM(Body4Matrix, 0, 0.3f/1.2f, 0.3f, 0.3f/1.2f);
        Matrix.rotateM(Body4Matrix, 0, 180f, 0, 0, 1);

    }
    private float[] myMatrix = new float[16];
    private float[] mMatrix = new float[16];
    private SphereEX mHemisphere = new SphereEX(360,0,90,64,16);
    private ConeEX mCylinder = new ConeEX(1f,1f,360f,64);
    private ConeEX mDisk = new ConeEX(0f,0f,360f,64);
    private TorusEX mTorusEX = new TorusEX(0.2f,360f,0f,90f,64,16);

    public void drawDroid() {
        float[] myMatrix = new float[16];
        Matrix.setIdentityM(myMatrix, 0);
        drawDroid(myMatrix);
    }

    public void drawDroid(float[] DroidMatrix) {
        System.arraycopy(DroidMatrix, 0, myMatrix, 0, 16);

        //ドロイド君の描画
        //頭mHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,Head1Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, .25f, 1f, 5.f);
        //頭mDisk円盤の描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,Head2Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mDisk.draw(0f, 1f, .25f, 1f, 5.f);
        //左目mHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,LeftEyeMatrix,0);
       GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 0f, 1f, 1f, 5.f);
        //右目mHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,RightEyeMatrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 0f, 1f, 1f, 5.f);
        //左角mCylinderの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,LeftPole1Matrix,0);
       GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, .25f, 1f, 5.f);
        //右角mCylinderの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,RightPole1Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, .25f, 1f, 5.f);
        //左角のふたmHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,LeftPole2Matrix,0);
       GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, .25f, 1f, 5.f);
        //右角のふたmHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,RightPole2Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, .25f, 1f, 5.f);

        //左腕mCylinderの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,LeftArm1Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, .25f, 1f, 5.f);
        //右腕mCylinderの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,RightArm1Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, .25f, 1f, 5.f);
        //左腕のふた上mHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,LeftArm2Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, .25f, 1f, 5.f);
        //右腕のふた上mHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,RightArm2Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, .25f, 1f, 5.f);
        //左腕のふた下mHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,LeftArm3Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, .25f, 1f, 5.f);
        //右腕のふた下mHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,RightArm3Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, .25f, 1f, 5.f);

        //左足mCylinderの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,LeftLeg1Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, .25f, 1f, 5.f);
        //右足mCylinderの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,RightLeg1Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, .25f, 1f, 5.f);
        //左足のふた下mHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,LeftLeg2Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, .25f, 1f, 5.f);
        //右足のふた下mHemisphereの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,RightLeg2Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, .25f, 1f, 5.f);

        //胴体mCylinderの描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,Body1Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, .25f, 1f, 5.f);
        //胴体下部mDisk円盤の描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,Body2Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mDisk.draw(0f, 1f, .25f, 1f, 5.f);
        //胴体上部mDisk円盤の描画
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,Body3Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mDisk.draw(0f, 1f, .25f, 1f, 5.f);
        //胴体下部のまるみ
        Matrix.multiplyMM(mMatrix,0,myMatrix,0,Body4Matrix,0);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mTorusEX.draw(0f, 1f, .25f, 1f, 5.f);
    }
}
/*
        //ドロイド君の描画
        float headfact1=.9f; //頭部の縦圧縮率
        float headfact2=.5f; //頭部の上方向移動量
        //頭mHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(mMatrix, 0, 0.3f, 0.3f*headfact1, 0.3f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, 0f, 1f, 5.f);
        //頭mDisk円盤の描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(mMatrix, 0, 0.3f, 0.3f*headfact1, 0.3f);
        Matrix.rotateM(mMatrix, 0, 180f, 0, 0, 1);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mDisk.draw(0f, 1f, 0f, 1f, 5.f);
        //左目mHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(mMatrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(mMatrix, 0, 25f, 0, 1, 0);
        Matrix.rotateM(mMatrix, 0, -30f, 1, 0, 0);
        Matrix.translateM(mMatrix, 0, 0f, 0f, .28f);
        Matrix.rotateM(mMatrix, 0, 90f, 1, 0, 0);
        Matrix.scaleM(mMatrix, 0, 0.03f, 0.03f, 0.03f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 0f, 1f, 1f, 5.f);
        //右目mHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(mMatrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(mMatrix, 0, -25f, 0, 1, 0);
        Matrix.rotateM(mMatrix, 0, -30f, 1, 0, 0);
        Matrix.translateM(mMatrix, 0, 0f, 0f, .28f);
        Matrix.rotateM(mMatrix, 0, 90f, 1, 0, 0);
        Matrix.scaleM(mMatrix, 0, 0.03f, 0.03f, 0.03f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 0f, 1f, 1f, 5.f);
        //左角mCylinderの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(mMatrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(mMatrix, 0, 25, 0, 0, 1);
        Matrix.scaleM(mMatrix, 0, 0.02f, 0.4f, 0.02f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, 0f, 1f, 5.f);
        //右角mCylinderの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(mMatrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(mMatrix, 0, -25, 0, 0, 1);
        Matrix.scaleM(mMatrix, 0, 0.02f, 0.4f, 0.02f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, 0f, 1f, 5.f);
        //左角のふたmHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);  //ここではすでに設定されているので省略可
        Matrix.translateM(mMatrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(mMatrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(mMatrix, 0, 25, 0, 0, 1);
        Matrix.translateM(mMatrix, 0, 0f, 0.4f, 0f);
        Matrix.scaleM(mMatrix, 0, 0.02f, 0.02f, 0.02f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, 0f, 1f, 5.f);
        //右角のふたmHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);  //ここではすでに設定されているので省略可
        Matrix.translateM(mMatrix, 0, 0f, headfact2, 0f);
        Matrix.scaleM(mMatrix, 0, 1f, headfact1, 1f);
        Matrix.rotateM(mMatrix, 0, -25, 0, 0, 1);
        Matrix.translateM(mMatrix, 0, 0f, 0.4f, 0f);
        Matrix.scaleM(mMatrix, 0, 0.02f, 0.02f, 0.02f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, 0f, 1f, 5.f);

        float lhandfact1=0.1f; //左腕上方向移動量
        float rhandfact1=0.1f+.33f; //左腕上方向移動量
        float hendfat2=.32f; //腕の長さ
        float hendfat3=.38f; //腕の横方向移動距離
        //左腕mCylinderの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, hendfat3, lhandfact1, 0f);
        Matrix.scaleM(mMatrix, 0, 0.07f, hendfat2, 0.07f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, 0f, 1f, 5.f);
        //右腕mCylinderの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, -hendfat3, rhandfact1, 0f);
        Matrix.scaleM(mMatrix, 0, 0.07f, hendfat2, 0.07f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, 0f, 1f, 5.f);
        //左腕のふた上mHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, hendfat3, hendfat2+lhandfact1, 0f);
        Matrix.scaleM(mMatrix, 0, 0.07f, 0.07f, 0.07f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, 0f, 1f, 5.f);
        //右腕のふた上mHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, -hendfat3, hendfat2+rhandfact1, 0f);
        Matrix.scaleM(mMatrix, 0, 0.07f, 0.07f, 0.07f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, 0f, 1f, 5.f);
        //左腕のふた下mHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, hendfat3, lhandfact1, 0f);
        Matrix.rotateM(mMatrix, 0, 180, 0, 0, 1);
        Matrix.scaleM(mMatrix, 0, 0.07f, 0.07f, 0.07f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, 0f, 1f, 5.f);
        //右腕のふた下mHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, -hendfat3,rhandfact1, 0f);
        Matrix.rotateM(mMatrix, 0, 180, 0, 0, 1);
        Matrix.scaleM(mMatrix, 0, 0.07f, 0.07f, 0.07f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, 0f, 1f, 5.f);

        //左足mCylinderの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, 0.15f,-0.2f, 0f);
        Matrix.scaleM(mMatrix, 0, 0.06f, 0.2f, 0.1f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, 0f, 1f, 5.f);
        //右足mCylinderの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, -0.15f,-0.2f, 0f);
        Matrix.scaleM(mMatrix, 0, 0.06f, 0.2f, 0.1f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, 0f, 1f, 5.f);
        //左足のふた下mHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, 0.15f, -0.2f, 0f);
        Matrix.rotateM(mMatrix, 0, 180, 0, 0, 1);
        Matrix.scaleM(mMatrix, 0, 0.06f, 0.06f, 0.1f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, 0f, 1f, 5.f);
        //右足のふた下mHemisphereの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, -0.15f, -0.2f, 0f);
        Matrix.rotateM(mMatrix, 0, 180, 0, 0, 1);
        Matrix.scaleM(mMatrix, 0, 0.06f, 0.06f, 0.1f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mHemisphere.draw(0f, 1f, 0f, 1f, 5.f);

        //胴体mCylinderの描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.scaleM(mMatrix, 0, 0.3f, 0.48f, 0.3f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mCylinder.draw(0f, 1f, 0f, 1f, 5.f);
        //胴体下部mDisk円盤の描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.scaleM(mMatrix, 0, 0.3f, 0.3f, 0.3f);
        Matrix.rotateM(mMatrix, 0, 180f, 0, 0, 1);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mDisk.draw(0f, 1f, 0f, 1f, 5.f);
        //胴体上部mDisk円盤の描画
        Matrix.setIdentityM(mMatrix, 0);
        Matrix.translateM(mMatrix, 0, 0f, 0.48f, 0f);
        Matrix.scaleM(mMatrix, 0, 0.3f, 0.3f, 0.3f);
        GLES.updateMatrix(mMatrix);//現在の変換行列をシェーダに指定
        mDisk.draw(0f, 1f, 0f, 1f, 5.f);


 */