package jp.gr.java_conf.coskx.stereoprojtest;

import androidx.appcompat.app.AppCompatActivity;
import android.graphics.Color;
import android.os.Bundle;
import android.view.GestureDetector;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;

//public class MainActivity extends AppCompatActivity {
public class MainActivity extends AppCompatActivity {

    private MyGLSurfaceView glView;
    private GestureDetector gesDetector = null;

    public View mTableLayout;

    private Button btngo;
    private Button btnstop;
    private Button btnswitch;
    private Button btn45;
    private Button btn60;
    private Button btn90;
    private Button btn120;
    private int swvalue=0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        //GLサーフェスビュー
        glView=(MyGLSurfaceView)findViewById(R.id.id_myGLview);
        gesDetector = new GestureDetector(this, (GestureDetector.OnGestureListener) glView);

        //上面のtablelayoutを取得
        mTableLayout=(View)findViewById(R.id.UpperLayout);
        glView.setUpperLayout(mTableLayout);

        //buttonを取得
        btngo = (Button)findViewById(R.id.b_go);
        btngo.setOnClickListener(clicked);
        btnstop = (Button)findViewById(R.id.b_stop);
        btnstop.setOnClickListener(clicked);
        btnswitch = (Button)findViewById(R.id.b_switch);
        btnswitch.setOnClickListener(clicked);
        btn45 = (Button)findViewById(R.id.b_va45);
        btn45.setOnClickListener(clicked);
        btn60 = (Button)findViewById(R.id.b_va60);
        btn60.setOnClickListener(clicked);
        btn90 = (Button)findViewById(R.id.b_va90);
        btn90.setOnClickListener(clicked);
        btn120 = (Button)findViewById(R.id.b_va120);
        btn120.setOnClickListener(clicked);
    }

    @Override
    public void onResume() {
        super.onResume();
        swvalue=0;
        btnswitch.setTextColor(Color.parseColor("#ffffff"));
        GLES.setProjectionMethod(swvalue);
    }

    private View.OnClickListener clicked = new View.OnClickListener() {
        public void onClick(View v) {
            switch (v.getId()) {
                case R.id.b_go:
                    glView.setRotationVelocity(1f);
                    break;
                case R.id.b_stop:
                    glView.setRotationVelocity(0f);
                    break;
                case R.id.b_switch:
                    swvalue=1-swvalue;
                    GLES.setProjectionMethod(swvalue);
                    btnswitch.setTextColor(swvalue==1? Color.parseColor("#ff8080"):Color.parseColor("#ffffff"));
                    break;
                case R.id.b_va45:
                    glView.renderer.setViewangle(45f);
                    break;
                case R.id.b_va60:
                    glView.renderer.setViewangle(60f);
                    break;
                case R.id.b_va90:
                    glView.renderer.setViewangle(90f);
                    break;
                case R.id.b_va120:
                    glView.renderer.setViewangle(120f);
                    break;
            }
            mTableLayout.setVisibility(View.INVISIBLE);
        }
    };

    @Override
    public boolean onTouchEvent(MotionEvent event){
        return gesDetector.onTouchEvent(event);
    }
}
